Subject: cores & numbering schemes

From: "M. Strata Rose" <[email-masked]>
Date: Mon, 8 Nov 1993 11:32:33 -0800

I've been working on designing utilites to move objects in and out of the
database and on a core-load and secondary-core-load system/protocol.  The
work I'm doing involves a mechanism for "sharing" objects in a limited way
between databases by specifying an authentication protocol a la Kerberos by
which objects may be invoked/created on remote servers.  This involves 
special object-handling code that can classify objects according to their
relation to core and secondary-core objects and only move the attributes
or pieces that differ from the core description.  Initially there will be an
upper bound on how big an object you can load across the net this way, but I
don't have enough data yet to say what that bound might be.

However, many cases where people want to "move" objects, what they
really want is to execute a particular object on another MOO, so I am
addressing that case as well, remote execution of native and imported
objects with output going over the wire to the original invoking
object.  This too is a several mile wide potential security hole which
I am trying to design very carefully.  The VCN server is
being built with support for PGP encrypted sessions and on-the-fly
authentication of individual sensitive objects, as well as potential
support for the entire session to be sent in a session key to the
client.  

As with any security system based on encryption, you are 
only as secure as your key is secret, but given the nature of passwords
and encryption built into VCN, there will be strong incentive not to 
give away your key, as that will grant someone full privileges as you.

The part that's bogging me down a little is "what's the best way to make the
server handle local and foreign objects on various levels: efficiency,
compatability, and security?"  A friend has suggested a system which may
work, but it's too soon to post details yet.

I will post more as I have time...

_Strata

M. Strata Rose
Unix & Network Consultant, SysAdmin & Internet Information 
Virtual City (TM) Network
[email-masked] | [email-masked] | [email-masked]